#if defined(__linux__)
#if defined(__i386__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       331

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getcwd      183

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_exit, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__fork
	.type	__fork, @function
__fork:
	push	%ebx
	mov	$SYS_fork, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__wait4
	.type	__wait4, @function
__wait4:
	push	%ebx
	mov	0x14(%esp), %esi
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_wait4, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__kill
	.type	__kill, @function
__kill:
	push	%ebx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_kill, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__execve
	.type	__execve, @function
__execve:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_execve, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__read
	.type	__read, @function
__read:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_read, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__write
	.type	__write, @function
__write:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_write, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__open
	.type	__open, @function
__open:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_open, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__close
	.type	__close, @function
__close:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_close, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__dup
	.type	__dup, @function
__dup:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_dup, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__pipe
	.type	__pipe, @function
__pipe:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_pipe, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__dup2
	.type	__dup2, @function
__dup2:
	push	%ebx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_dup2, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__pipe2
	.type	__pipe2, @function
__pipe2:
	push	%ebx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_pipe2, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__sigaction
	.type	__sigaction, @function
__sigaction:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_sigaction, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__sigprocmask
	.type	__sigprocmask, @function
__sigprocmask:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_sigprocmask, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__getpid
	.type	__getpid, @function
__getpid:
	push	%ebx
	mov	$SYS_getpid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__getppid
	.type	__getppid, @function
__getppid:
	push	%ebx
	mov	$SYS_getppid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__getsid
	.type	__getsid, @function
__getsid:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_getsid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__setsid
	.type	__setsid, @function
__setsid:
	push	%ebx
	mov	$SYS_setsid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__getpgid
	.type	__getpgid, @function
__getpgid:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_getpgid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__setpgid
	.type	__setpgid, @function
__setpgid:
	push	%ebx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_setpgid, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__getpgrp
	.type	__getpgrp, @function
__getpgrp:
	push	%ebx
	mov	$SYS_getpgrp, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__chdir
	.type	__chdir, @function
__chdir:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_chdir, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_ioctl, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__brk
	.type	__brk, @function
__brk:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_brk, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	____getcwd
	.type	____getcwd, @function
____getcwd:
	push	%ebx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_getcwd, %eax
	int	$0x80
	pop	%ebx
	ret
#endif
#endif
